package mod.hey.studios.moreblock;

import android.util.Pair;
import android.widget.RadioGroup;

import com.besome.sketch.editor.LogicEditorActivity;
import com.sketchware.remod.Resources;

import java.util.Iterator;

public class ReturnMoreblockManager {

    public static String getLogicEditorTitle(String str) {
        return str.replaceAll("\\[.*]", " (returns " + getMbTypeList(str) + ")");
    }

    public static String getMbEnd(String str) {
        if (str.equals(" ")) {
            return ";";
        } else {
            return "";
        }
    }

    public static String getMbName(String str) {
        String name = str;

        if (str.contains("[") && str.contains("]")) {
            name = str.replaceAll("\\[.*]", "");
        }

        return name;
    }

    public static String getMbType(String str) {
        try {
            if (!str.contains("]") || !str.contains("[")) return "void";

            return str.substring(str.indexOf("[") + 1, str.lastIndexOf("]"));
        } catch (Exception e) {
            return "void";
        }
    }

    public static String getMbTypeList(String str) {
        try {
            if (!str.contains("]") || !str.contains("["))
                return "void";

            String substring = str.substring(str.indexOf("[") + 1, str.lastIndexOf("]"));
            if (substring.contains("|")) {
                substring = substring.split("\\|")[1];
            }

            return substring;
        } catch (Exception e) {
            return "void";
        }
    }

    public static String getMbTypeCode(String str) {
        try {
            if (!str.contains("]") || !str.contains("[")) return "void";

            String substring = str.substring(str.indexOf("[") + 1, str.lastIndexOf("]"));
            if (substring.contains("|")) {
                String[] split = substring.split("\\|");

                if (substring.equals("a|Map")) {
                    substring = "HashMap<String, Object>";

                } else if (substring.equals("l|List String")) {
                    substring = "ArrayList<String>";

                } else if (substring.equals("l|List Map")) {
                    substring = "ArrayList<HashMap<String, Object>>";

                } else if (split.length == 2) {
                    substring = split[1];

                } else if (split.length == 3) {
                    substring = split[2];
                }
            }

            return substring;
        } catch (Exception e) {
            return "void";
        }
    }

    public static String getMbTypeFromRadioButton(RadioGroup radioGroup) {
        String type;
        switch (radioGroup.getCheckedRadioButtonId()) {
            case Resources.id.radio_mb_type_string:
                type = "s";
                break;

            case Resources.id.radio_mb_type_number:
                type = "d";
                break;

            case Resources.id.radio_mb_type_boolean:
                type = "b";
                break;

            case Resources.id.radio_mb_type_map:
                type = "a|Map";
                break;

            case Resources.id.radio_mb_type_liststring:
                type = "l|List String";
                break;

            case Resources.id.radio_mb_type_listmap:
                type = "l|List Map";
                break;

            case Resources.id.radio_mb_type_view:
                type = "v|View";
                break;

            // What?
            case Resources.id.manage_attr_listview:
            case Resources.id.add_attr_listview:
            case Resources.id.add_attr_fab:
            case Resources.id.cus_attr_layout:
            case Resources.id.cus_attr_text:
            case Resources.id.cus_attr_btn:
            case Resources.id.dialog_input_attr:
            case Resources.id.dialog_btn_cancel:
            case Resources.id.dialog_btn_save:
            case Resources.id.dialog_input_res:
            case Resources.id.dialog_input_value:
            default:
                type = " ";
                break;
        }
        return type;
    }

    public static void listMoreblocks(Iterator<Pair<String, String>> it, LogicEditorActivity logicEditorActivity) {
        while (it.hasNext()) {
            String str = it.next().second;
            String moreblockChar = getMoreblockChar(str);

            if (moreblockChar.contains("|")) {
                String[] split = moreblockChar.split("\\|");
                logicEditorActivity.a(getMbName(str), split[0], split[1], "definedFunc").setTag(getMbName(str));
            } else {
                logicEditorActivity.a(getMbName(str), moreblockChar, "definedFunc").setTag(getMbName(str));
            }
        }
    }

    public static String getMoreblockChar(String str) {
        String moreBlockChar;
        String mbType = getMbType(str);

        if (mbType.equals("void")) {
            moreBlockChar = " ";
        } else if (mbType.equals("String")) {
            moreBlockChar = "s";
        } else if (mbType.equals("double")) {
            moreBlockChar = "d";
        } else if (mbType.equals("boolean")) {
            moreBlockChar = "b";
        } else if (mbType.contains("|")) {
            return mbType;
        } else {
            moreBlockChar = " ";
        }

        return moreBlockChar;
    }

    public static String injectMbType(String str, String str2, String str3) {
        String str4 = str;

        if (!str3.equals(" ")) {
            if (str3.contains("|")) {
                str4 = injectToMbName(str4, str2, str3);

            } else if (str3.equals("s")) {
                str4 = injectToMbName(str4, str2, "String");

            } else if (str3.equals("d")) {
                str4 = injectToMbName(str4, str2, "double");

            } else if (str3.equals("b")) {
                str4 = injectToMbName(str4, str2, "boolean");
            }
        }

        return str4;

    }

    public static String injectToMbName(String str, String str2, String str3) {
        String replaceFirst;

        if (str.equals(str2)) {
            replaceFirst = str + "[" + str3 + "]";
        } else {
            replaceFirst = str.replaceFirst(str2, str2 + "[" + str3 + "]");
        }

        return replaceFirst;
    }

    public static String getPreviewType(String str) {
        if (str.contains("|")) return "a";

        return str;
    }
}
